import csv  # noqa: F401
import os  # noqa: F401
import matplotlib.pyplot as plt
from numpy.polynomial import polynomial as poly  # noqa: F401


def parse_data(filename):
    '''
    Reads the data in `filename` and returns a dictionary of dictionaries of
    dictionaries.

    You will be asked to write this function in Problem 1.
    '''
    pass


def get_actual_production(data, country_code, year):
    '''
    Combines the "farmed" and "wild caught" fields from `data` for the given
    country and year into a single value. Returns an integer.

    You will be asked to write this function in Problem 2a.
    '''
    pass


def get_production_need(data, country_code, year):
    '''
    Based on the population and consumption values in `data`, calculates the
    amount of production that is needed to meet consumption needs for a given
    country in the given year. Returns a float.

    You will be asked to write this function in Problem 2b.
    '''
    pass


def plot_production_vs_consumption(data, country_code):
    '''
    Given a country code and the data dictionary, plots a line graph of the
    actual production against the calculated needed production over time.

    You will be asked to write this function in Problem 3.
    '''
    pass


def predict_need(data, country_code, predict_years):
    '''
    Returns a dictionary that represents a best-fit prediction line for the given
    `country_code` over the next `predict_years` years.

    You will be asked to write this function in Problem 4a.
    '''
    pass


def plot_linear_prediction(data, country_code):
    '''
    A function that takes the output of `parse_data("small.csv")` as its first
    parameter and a country code (e.g., "USA") as its second parameter. It
    then calls the `calculate_prediction` function with the production need
    data (from get_production_need) for the given country code, and then
    plots the best-fit line and prediction.

    NOTE: This is a complete function, you do not need to modify it. However,
    it relies on parse_data, get_production_need, and calculate_prediction to
    be implemented according to the assignment spec.

    You will be asked to run this function in Problem 4b.
    '''
    real_min_year = data['min_year']
    real_max_year = data['max_year']
    observed_need_years = list(range(real_min_year, real_max_year + 1))
    observed_need_values = [get_production_need(data, country_code, year)
                            for year in observed_need_years]
    plt.plot(observed_need_years, observed_need_values, label='data', linestyle='', marker='s')

    prediction = predict_need(data, country_code, 50)
    plt.plot(prediction['years'], prediction['values'],
             linestyle='--', label='best-fit prediction')

    plt.title('Predicted Production Need For ' + country_code)
    plt.xlabel('Year')
    plt.ylabel('Metric Tonnes')
    plt.legend()
    plt.savefig(os.path.dirname(__file__) + "/" + country_code + "_need_prediction.png")


def total_production_need(data, years_to_predict):
    '''
    Calculates the total production needed to meet consumption needs
    `years_to_predict` years from now. Returns a float.

    You will be asked to write this function in Problem 5a.
    '''
    pass


def min_year(fields):
    '''
    A helper function that, given a list of values, returns
    the minimum integer.

    You do not have to modify or even use this function, but it is here
    if you want to use it. It is suggested to use it in `parse_data`.
    '''
    return min([int(field) for field in fields
                if type(field) is int or field.isnumeric()])


def max_year(fields):
    '''
    A helper function that, given a list of values, returns 
    the maximum integer.

    You do not have to modify or even use this function, but it is here
    if you want to use it. It is suggested to use it in `parse_data`.
    '''
    return max([int(field) for field in fields
                if type(field) is int or field.isnumeric()])


if __name__ == "__main__":
    # Write your main code here. The code in this block should use the other
    # functions you've written and not make any calculations on its own.
    #
    # Hint: Our final solution only has about 4-5 lines of code here.

    # uncomment this line as part of Problem 4b. It assumes that the return
    # value from parse_data is assigned to a variable named `data`.
    # plot_linear_prediction(data, "USA")
